<?php

namespace App\Models\Equipment;

use App\Entities\Equipment\DefenceEntity;

class DefenceModel extends EquipmentModel
{
    const TABLE = "defenceinfo";
    const PK = "uid";
    const TITLE = "ip";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = DefenceEntity::class;
    protected $allowedFields = [
        "type",
        "ip",
        "accountid",
        "domain",
        "description",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "model":
            case "type":
                $rule = "required|trim|string";
                break;
            case "ip":
                $rule = "required|trim|valid_ip[both]"; //ipv4 , ipv6 , both(ipv4,ipv6)
                break;
            default:
                $rule = parent::getFieldRule($action, $field);
                break;
        }
        return $rule;
    }
}
